<?php
/**
 * DeliveryOrderReadonlyProperties
 *
 * PHP version 5
 *
 * @category Class
 * @package  Ensi\LogisticClient
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */

/**
 * Ensi Logistic
 *
 * Управление логистикой
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: mail@greensight.ru
 * Generated by: https://openapi-generator.tech
 * OpenAPI Generator version: 4.3.1
 */

/**
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

namespace Ensi\LogisticClient\Dto;

use \ArrayAccess;
use \Ensi\LogisticClient\ObjectSerializer;

/**
 * DeliveryOrderReadonlyProperties Class Doc Comment
 *
 * @category Class
 * @package  Ensi\LogisticClient
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */
class DeliveryOrderReadonlyProperties implements ModelInterface, ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $openAPIModelName = 'DeliveryOrderReadonlyProperties';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $openAPITypes = [
        'id' => 'int',
        'delivery_id' => 'int',
        'delivery_service_id' => 'int',
        'number' => 'string',
        'external_id' => 'string',
        'error_external_id' => 'string',
        'status_at' => '\DateTime',
        'external_status' => 'string',
        'external_status_at' => '\DateTime',
        'height' => 'int',
        'length' => 'int',
        'width' => 'int',
        'weight' => 'int',
        'shipment_method' => 'int',
        'delivery_method' => 'int',
        'delivery_date' => '\DateTime',
        'point_in_id' => 'int',
        'point_out_id' => 'int',
        'shipment_time_start' => '\DateTime',
        'shipment_time_end' => '\DateTime',
        'delivery_time_start' => '\DateTime',
        'delivery_time_end' => '\DateTime',
        'description' => 'string',
        'assessed_cost' => 'int',
        'delivery_cost' => 'int',
        'delivery_cost_vat' => 'float',
        'delivery_cost_pay' => 'int',
        'cod_cost' => 'int',
        'is_delivery_payed_by_recipient' => 'bool',
        'sender_is_seller' => 'bool',
        'sender_inn' => 'string',
        'sender_address' => '\Ensi\LogisticClient\Dto\Address',
        'sender_company_name' => 'string',
        'sender_contact_name' => 'string',
        'sender_email' => 'string',
        'sender_phone' => 'string',
        'sender_comment' => 'string',
        'recipient_address' => '\Ensi\LogisticClient\Dto\Address',
        'recipient_company_name' => 'string',
        'recipient_contact_name' => 'string',
        'recipient_email' => 'string',
        'recipient_phone' => 'string',
        'recipient_comment' => 'string',
        'created_at' => '\DateTime',
        'updated_at' => '\DateTime'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $openAPIFormats = [
        'id' => null,
        'delivery_id' => null,
        'delivery_service_id' => null,
        'number' => null,
        'external_id' => null,
        'error_external_id' => null,
        'status_at' => 'date-time',
        'external_status' => null,
        'external_status_at' => 'date-time',
        'height' => null,
        'length' => null,
        'width' => null,
        'weight' => null,
        'shipment_method' => null,
        'delivery_method' => null,
        'delivery_date' => 'date',
        'point_in_id' => null,
        'point_out_id' => null,
        'shipment_time_start' => 'date-time',
        'shipment_time_end' => 'date-time',
        'delivery_time_start' => 'date-time',
        'delivery_time_end' => 'date-time',
        'description' => null,
        'assessed_cost' => null,
        'delivery_cost' => null,
        'delivery_cost_vat' => 'float',
        'delivery_cost_pay' => null,
        'cod_cost' => null,
        'is_delivery_payed_by_recipient' => null,
        'sender_is_seller' => null,
        'sender_inn' => null,
        'sender_address' => null,
        'sender_company_name' => null,
        'sender_contact_name' => null,
        'sender_email' => null,
        'sender_phone' => null,
        'sender_comment' => null,
        'recipient_address' => null,
        'recipient_company_name' => null,
        'recipient_contact_name' => null,
        'recipient_email' => null,
        'recipient_phone' => null,
        'recipient_comment' => null,
        'created_at' => 'date-time',
        'updated_at' => 'date-time'
    ];

    /**
      * Array of nullable properties. Used for (de)serialization
      *
      * @var boolean[]
      */
    protected static $openAPINullables = [
        'id' => false,
        'delivery_id' => false,
        'delivery_service_id' => false,
        'number' => false,
        'external_id' => true,
        'error_external_id' => true,
        'status_at' => false,
        'external_status' => true,
        'external_status_at' => true,
        'height' => false,
        'length' => false,
        'width' => false,
        'weight' => false,
        'shipment_method' => false,
        'delivery_method' => false,
        'delivery_date' => true,
        'point_in_id' => true,
        'point_out_id' => true,
        'shipment_time_start' => true,
        'shipment_time_end' => true,
        'delivery_time_start' => true,
        'delivery_time_end' => true,
        'description' => true,
        'assessed_cost' => true,
        'delivery_cost' => false,
        'delivery_cost_vat' => true,
        'delivery_cost_pay' => false,
        'cod_cost' => true,
        'is_delivery_payed_by_recipient' => false,
        'sender_is_seller' => false,
        'sender_inn' => true,
        'sender_address' => true,
        'sender_company_name' => true,
        'sender_contact_name' => true,
        'sender_email' => true,
        'sender_phone' => true,
        'sender_comment' => true,
        'recipient_address' => true,
        'recipient_company_name' => true,
        'recipient_contact_name' => true,
        'recipient_email' => true,
        'recipient_phone' => true,
        'recipient_comment' => true,
        'created_at' => false,
        'updated_at' => false
    ];

    /**
      * If a nullable field gets set to null, insert it here
      *
      * @var boolean[]
      */
    protected $openAPINullablesSetToNull = [];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPITypes()
    {
        return self::$openAPITypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPIFormats()
    {
        return self::$openAPIFormats;
    }

        /**
     * Array of property to nullable mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPINullables()
    {
        return self::$openAPINullables;
    }

    /**
     * Array of nullable field names deliberately set to null
     *
     * @return array
     */
    public function getOpenAPINullablesSetToNull()
    {
        return $this->openAPINullablesSetToNull;
    }

    public function setOpenAPINullablesSetToNull($nullablesSetToNull)
    {
        $this->openAPINullablesSetToNull=$nullablesSetToNull;
        return $this;
    }

    /**
     * Checks if a property is nullable
     *
     * @return bool
     */
    public static function isNullable(string $property): bool
    {
        if (isset(self::openAPINullables()[$property])) {
            return self::openAPINullables()[$property];
        }

        return false;
    }

    /**
     * Checks if a nullable property is set to null.
     *
     * @return bool
     */
    public function isNullableSetToNull(string $property): bool
    {
        if (in_array($property, $this->getOpenAPINullablesSetToNull())) {
            return true;
        }
        return false;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'id' => 'id',
        'delivery_id' => 'delivery_id',
        'delivery_service_id' => 'delivery_service_id',
        'number' => 'number',
        'external_id' => 'external_id',
        'error_external_id' => 'error_external_id',
        'status_at' => 'status_at',
        'external_status' => 'external_status',
        'external_status_at' => 'external_status_at',
        'height' => 'height',
        'length' => 'length',
        'width' => 'width',
        'weight' => 'weight',
        'shipment_method' => 'shipment_method',
        'delivery_method' => 'delivery_method',
        'delivery_date' => 'delivery_date',
        'point_in_id' => 'point_in_id',
        'point_out_id' => 'point_out_id',
        'shipment_time_start' => 'shipment_time_start',
        'shipment_time_end' => 'shipment_time_end',
        'delivery_time_start' => 'delivery_time_start',
        'delivery_time_end' => 'delivery_time_end',
        'description' => 'description',
        'assessed_cost' => 'assessed_cost',
        'delivery_cost' => 'delivery_cost',
        'delivery_cost_vat' => 'delivery_cost_vat',
        'delivery_cost_pay' => 'delivery_cost_pay',
        'cod_cost' => 'cod_cost',
        'is_delivery_payed_by_recipient' => 'is_delivery_payed_by_recipient',
        'sender_is_seller' => 'sender_is_seller',
        'sender_inn' => 'sender_inn',
        'sender_address' => 'sender_address',
        'sender_company_name' => 'sender_company_name',
        'sender_contact_name' => 'sender_contact_name',
        'sender_email' => 'sender_email',
        'sender_phone' => 'sender_phone',
        'sender_comment' => 'sender_comment',
        'recipient_address' => 'recipient_address',
        'recipient_company_name' => 'recipient_company_name',
        'recipient_contact_name' => 'recipient_contact_name',
        'recipient_email' => 'recipient_email',
        'recipient_phone' => 'recipient_phone',
        'recipient_comment' => 'recipient_comment',
        'created_at' => 'created_at',
        'updated_at' => 'updated_at'
    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'id' => 'setId',
        'delivery_id' => 'setDeliveryId',
        'delivery_service_id' => 'setDeliveryServiceId',
        'number' => 'setNumber',
        'external_id' => 'setExternalId',
        'error_external_id' => 'setErrorExternalId',
        'status_at' => 'setStatusAt',
        'external_status' => 'setExternalStatus',
        'external_status_at' => 'setExternalStatusAt',
        'height' => 'setHeight',
        'length' => 'setLength',
        'width' => 'setWidth',
        'weight' => 'setWeight',
        'shipment_method' => 'setShipmentMethod',
        'delivery_method' => 'setDeliveryMethod',
        'delivery_date' => 'setDeliveryDate',
        'point_in_id' => 'setPointInId',
        'point_out_id' => 'setPointOutId',
        'shipment_time_start' => 'setShipmentTimeStart',
        'shipment_time_end' => 'setShipmentTimeEnd',
        'delivery_time_start' => 'setDeliveryTimeStart',
        'delivery_time_end' => 'setDeliveryTimeEnd',
        'description' => 'setDescription',
        'assessed_cost' => 'setAssessedCost',
        'delivery_cost' => 'setDeliveryCost',
        'delivery_cost_vat' => 'setDeliveryCostVat',
        'delivery_cost_pay' => 'setDeliveryCostPay',
        'cod_cost' => 'setCodCost',
        'is_delivery_payed_by_recipient' => 'setIsDeliveryPayedByRecipient',
        'sender_is_seller' => 'setSenderIsSeller',
        'sender_inn' => 'setSenderInn',
        'sender_address' => 'setSenderAddress',
        'sender_company_name' => 'setSenderCompanyName',
        'sender_contact_name' => 'setSenderContactName',
        'sender_email' => 'setSenderEmail',
        'sender_phone' => 'setSenderPhone',
        'sender_comment' => 'setSenderComment',
        'recipient_address' => 'setRecipientAddress',
        'recipient_company_name' => 'setRecipientCompanyName',
        'recipient_contact_name' => 'setRecipientContactName',
        'recipient_email' => 'setRecipientEmail',
        'recipient_phone' => 'setRecipientPhone',
        'recipient_comment' => 'setRecipientComment',
        'created_at' => 'setCreatedAt',
        'updated_at' => 'setUpdatedAt'
    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'id' => 'getId',
        'delivery_id' => 'getDeliveryId',
        'delivery_service_id' => 'getDeliveryServiceId',
        'number' => 'getNumber',
        'external_id' => 'getExternalId',
        'error_external_id' => 'getErrorExternalId',
        'status_at' => 'getStatusAt',
        'external_status' => 'getExternalStatus',
        'external_status_at' => 'getExternalStatusAt',
        'height' => 'getHeight',
        'length' => 'getLength',
        'width' => 'getWidth',
        'weight' => 'getWeight',
        'shipment_method' => 'getShipmentMethod',
        'delivery_method' => 'getDeliveryMethod',
        'delivery_date' => 'getDeliveryDate',
        'point_in_id' => 'getPointInId',
        'point_out_id' => 'getPointOutId',
        'shipment_time_start' => 'getShipmentTimeStart',
        'shipment_time_end' => 'getShipmentTimeEnd',
        'delivery_time_start' => 'getDeliveryTimeStart',
        'delivery_time_end' => 'getDeliveryTimeEnd',
        'description' => 'getDescription',
        'assessed_cost' => 'getAssessedCost',
        'delivery_cost' => 'getDeliveryCost',
        'delivery_cost_vat' => 'getDeliveryCostVat',
        'delivery_cost_pay' => 'getDeliveryCostPay',
        'cod_cost' => 'getCodCost',
        'is_delivery_payed_by_recipient' => 'getIsDeliveryPayedByRecipient',
        'sender_is_seller' => 'getSenderIsSeller',
        'sender_inn' => 'getSenderInn',
        'sender_address' => 'getSenderAddress',
        'sender_company_name' => 'getSenderCompanyName',
        'sender_contact_name' => 'getSenderContactName',
        'sender_email' => 'getSenderEmail',
        'sender_phone' => 'getSenderPhone',
        'sender_comment' => 'getSenderComment',
        'recipient_address' => 'getRecipientAddress',
        'recipient_company_name' => 'getRecipientCompanyName',
        'recipient_contact_name' => 'getRecipientContactName',
        'recipient_email' => 'getRecipientEmail',
        'recipient_phone' => 'getRecipientPhone',
        'recipient_comment' => 'getRecipientComment',
        'created_at' => 'getCreatedAt',
        'updated_at' => 'getUpdatedAt'
    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$openAPIModelName;
    }

    

    

    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->setIfExists('id', $data, null);
        $this->setIfExists('delivery_id', $data, null);
        $this->setIfExists('delivery_service_id', $data, null);
        $this->setIfExists('number', $data, null);
        $this->setIfExists('external_id', $data, null);
        $this->setIfExists('error_external_id', $data, null);
        $this->setIfExists('status_at', $data, null);
        $this->setIfExists('external_status', $data, null);
        $this->setIfExists('external_status_at', $data, null);
        $this->setIfExists('height', $data, null);
        $this->setIfExists('length', $data, null);
        $this->setIfExists('width', $data, null);
        $this->setIfExists('weight', $data, null);
        $this->setIfExists('shipment_method', $data, null);
        $this->setIfExists('delivery_method', $data, null);
        $this->setIfExists('delivery_date', $data, null);
        $this->setIfExists('point_in_id', $data, null);
        $this->setIfExists('point_out_id', $data, null);
        $this->setIfExists('shipment_time_start', $data, null);
        $this->setIfExists('shipment_time_end', $data, null);
        $this->setIfExists('delivery_time_start', $data, null);
        $this->setIfExists('delivery_time_end', $data, null);
        $this->setIfExists('description', $data, null);
        $this->setIfExists('assessed_cost', $data, null);
        $this->setIfExists('delivery_cost', $data, null);
        $this->setIfExists('delivery_cost_vat', $data, null);
        $this->setIfExists('delivery_cost_pay', $data, null);
        $this->setIfExists('cod_cost', $data, null);
        $this->setIfExists('is_delivery_payed_by_recipient', $data, null);
        $this->setIfExists('sender_is_seller', $data, null);
        $this->setIfExists('sender_inn', $data, null);
        $this->setIfExists('sender_address', $data, null);
        $this->setIfExists('sender_company_name', $data, null);
        $this->setIfExists('sender_contact_name', $data, null);
        $this->setIfExists('sender_email', $data, null);
        $this->setIfExists('sender_phone', $data, null);
        $this->setIfExists('sender_comment', $data, null);
        $this->setIfExists('recipient_address', $data, null);
        $this->setIfExists('recipient_company_name', $data, null);
        $this->setIfExists('recipient_contact_name', $data, null);
        $this->setIfExists('recipient_email', $data, null);
        $this->setIfExists('recipient_phone', $data, null);
        $this->setIfExists('recipient_comment', $data, null);
        $this->setIfExists('created_at', $data, null);
        $this->setIfExists('updated_at', $data, null);
    }

    public function setIfExists(string $variableName, $fields, $defaultValue)
    {
        if (is_array($fields) && array_key_exists($variableName, $fields) && is_null($fields[$variableName]) && self::isNullable($variableName)) {
            array_push($this->openAPINullablesSetToNull, $variableName);
        }

        $this->container[$variableName] = isset($fields[$variableName]) ? $fields[$variableName] : $defaultValue;

        return $this;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        if ($this->container['id'] === null) {
            $invalidProperties[] = "'id' can't be null";
        }
        if ($this->container['delivery_id'] === null) {
            $invalidProperties[] = "'delivery_id' can't be null";
        }
        if ($this->container['delivery_service_id'] === null) {
            $invalidProperties[] = "'delivery_service_id' can't be null";
        }
        if ($this->container['number'] === null) {
            $invalidProperties[] = "'number' can't be null";
        }
        if ($this->container['external_id'] === null) {
            $invalidProperties[] = "'external_id' can't be null";
        }
        if ($this->container['error_external_id'] === null) {
            $invalidProperties[] = "'error_external_id' can't be null";
        }
        if ($this->container['status_at'] === null) {
            $invalidProperties[] = "'status_at' can't be null";
        }
        if ($this->container['external_status'] === null) {
            $invalidProperties[] = "'external_status' can't be null";
        }
        if ($this->container['external_status_at'] === null) {
            $invalidProperties[] = "'external_status_at' can't be null";
        }
        if ($this->container['height'] === null) {
            $invalidProperties[] = "'height' can't be null";
        }
        if ($this->container['length'] === null) {
            $invalidProperties[] = "'length' can't be null";
        }
        if ($this->container['width'] === null) {
            $invalidProperties[] = "'width' can't be null";
        }
        if ($this->container['weight'] === null) {
            $invalidProperties[] = "'weight' can't be null";
        }
        if ($this->container['shipment_method'] === null) {
            $invalidProperties[] = "'shipment_method' can't be null";
        }
        if ($this->container['delivery_method'] === null) {
            $invalidProperties[] = "'delivery_method' can't be null";
        }
        if ($this->container['delivery_date'] === null) {
            $invalidProperties[] = "'delivery_date' can't be null";
        }
        if ($this->container['point_in_id'] === null) {
            $invalidProperties[] = "'point_in_id' can't be null";
        }
        if ($this->container['point_out_id'] === null) {
            $invalidProperties[] = "'point_out_id' can't be null";
        }
        if ($this->container['shipment_time_start'] === null) {
            $invalidProperties[] = "'shipment_time_start' can't be null";
        }
        if ($this->container['shipment_time_end'] === null) {
            $invalidProperties[] = "'shipment_time_end' can't be null";
        }
        if ($this->container['delivery_time_start'] === null) {
            $invalidProperties[] = "'delivery_time_start' can't be null";
        }
        if ($this->container['delivery_time_end'] === null) {
            $invalidProperties[] = "'delivery_time_end' can't be null";
        }
        if ($this->container['description'] === null) {
            $invalidProperties[] = "'description' can't be null";
        }
        if ($this->container['assessed_cost'] === null) {
            $invalidProperties[] = "'assessed_cost' can't be null";
        }
        if ($this->container['delivery_cost'] === null) {
            $invalidProperties[] = "'delivery_cost' can't be null";
        }
        if ($this->container['delivery_cost_vat'] === null) {
            $invalidProperties[] = "'delivery_cost_vat' can't be null";
        }
        if ($this->container['delivery_cost_pay'] === null) {
            $invalidProperties[] = "'delivery_cost_pay' can't be null";
        }
        if ($this->container['cod_cost'] === null) {
            $invalidProperties[] = "'cod_cost' can't be null";
        }
        if ($this->container['is_delivery_payed_by_recipient'] === null) {
            $invalidProperties[] = "'is_delivery_payed_by_recipient' can't be null";
        }
        if ($this->container['sender_is_seller'] === null) {
            $invalidProperties[] = "'sender_is_seller' can't be null";
        }
        if ($this->container['sender_inn'] === null) {
            $invalidProperties[] = "'sender_inn' can't be null";
        }
        if ($this->container['sender_address'] === null) {
            $invalidProperties[] = "'sender_address' can't be null";
        }
        if ($this->container['sender_company_name'] === null) {
            $invalidProperties[] = "'sender_company_name' can't be null";
        }
        if ($this->container['sender_contact_name'] === null) {
            $invalidProperties[] = "'sender_contact_name' can't be null";
        }
        if ($this->container['sender_email'] === null) {
            $invalidProperties[] = "'sender_email' can't be null";
        }
        if ($this->container['sender_phone'] === null) {
            $invalidProperties[] = "'sender_phone' can't be null";
        }
        if ($this->container['sender_comment'] === null) {
            $invalidProperties[] = "'sender_comment' can't be null";
        }
        if ($this->container['recipient_address'] === null) {
            $invalidProperties[] = "'recipient_address' can't be null";
        }
        if ($this->container['recipient_company_name'] === null) {
            $invalidProperties[] = "'recipient_company_name' can't be null";
        }
        if ($this->container['recipient_contact_name'] === null) {
            $invalidProperties[] = "'recipient_contact_name' can't be null";
        }
        if ($this->container['recipient_email'] === null) {
            $invalidProperties[] = "'recipient_email' can't be null";
        }
        if ($this->container['recipient_phone'] === null) {
            $invalidProperties[] = "'recipient_phone' can't be null";
        }
        if ($this->container['recipient_comment'] === null) {
            $invalidProperties[] = "'recipient_comment' can't be null";
        }
        if ($this->container['created_at'] === null) {
            $invalidProperties[] = "'created_at' can't be null";
        }
        if ($this->container['updated_at'] === null) {
            $invalidProperties[] = "'updated_at' can't be null";
        }
        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {
        return count($this->listInvalidProperties()) === 0;
    }


    /**
     * Gets id
     *
     * @return int
     */
    public function getId()
    {
        return $this->container['id'];
    }

    /**
     * Sets id
     *
     * @param int $id Идентификатор заказа на доставку
     *
     * @return $this
     */
    public function setId($id)
    {


        /*if (is_null($id)) {
            throw new \InvalidArgumentException('non-nullable id cannot be null');
        }*/
        $this->container['id'] = $id;

        return $this;
    }

    /**
     * Gets delivery_id
     *
     * @return int
     */
    public function getDeliveryId()
    {
        return $this->container['delivery_id'];
    }

    /**
     * Sets delivery_id
     *
     * @param int $delivery_id Id Отправления в OMS
     *
     * @return $this
     */
    public function setDeliveryId($delivery_id)
    {


        /*if (is_null($delivery_id)) {
            throw new \InvalidArgumentException('non-nullable delivery_id cannot be null');
        }*/
        $this->container['delivery_id'] = $delivery_id;

        return $this;
    }

    /**
     * Gets delivery_service_id
     *
     * @return int
     */
    public function getDeliveryServiceId()
    {
        return $this->container['delivery_service_id'];
    }

    /**
     * Sets delivery_service_id
     *
     * @param int $delivery_service_id delivery_service_id
     *
     * @return $this
     */
    public function setDeliveryServiceId($delivery_service_id)
    {


        /*if (is_null($delivery_service_id)) {
            throw new \InvalidArgumentException('non-nullable delivery_service_id cannot be null');
        }*/
        $this->container['delivery_service_id'] = $delivery_service_id;

        return $this;
    }

    /**
     * Gets number
     *
     * @return string
     */
    public function getNumber()
    {
        return $this->container['number'];
    }

    /**
     * Sets number
     *
     * @param string $number Номер заказа на доставку внутри платформы (совпадает с номером Отправления в OMS)
     *
     * @return $this
     */
    public function setNumber($number)
    {


        /*if (is_null($number)) {
            throw new \InvalidArgumentException('non-nullable number cannot be null');
        }*/
        $this->container['number'] = $number;

        return $this;
    }

    /**
     * Gets external_id
     *
     * @return string|null
     */
    public function getExternalId()
    {
        return $this->container['external_id'];
    }

    /**
     * Sets external_id
     *
     * @param string|null $external_id Номер заказа на доставку у службы доставки (не заполняется при создании)
     *
     * @return $this
     */
    public function setExternalId($external_id)
    {

        if (is_null($external_id)) {
            array_push($this->openAPINullablesSetToNull, 'external_id');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('external_id', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['external_id'] = $external_id;

        return $this;
    }

    /**
     * Gets error_external_id
     *
     * @return string|null
     */
    public function getErrorExternalId()
    {
        return $this->container['error_external_id'];
    }

    /**
     * Sets error_external_id
     *
     * @param string|null $error_external_id Текст последней ошибки при создании заказа на доставку в службе доставки
     *
     * @return $this
     */
    public function setErrorExternalId($error_external_id)
    {

        if (is_null($error_external_id)) {
            array_push($this->openAPINullablesSetToNull, 'error_external_id');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('error_external_id', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['error_external_id'] = $error_external_id;

        return $this;
    }

    /**
     * Gets status_at
     *
     * @return \DateTime
     */
    public function getStatusAt()
    {
        return $this->container['status_at'];
    }

    /**
     * Sets status_at
     *
     * @param \DateTime $status_at Дата и время изменения статуса заказа на доставку внутри платформы
     *
     * @return $this
     */
    public function setStatusAt($status_at)
    {


        /*if (is_null($status_at)) {
            throw new \InvalidArgumentException('non-nullable status_at cannot be null');
        }*/
        $this->container['status_at'] = $status_at;

        return $this;
    }

    /**
     * Gets external_status
     *
     * @return string|null
     */
    public function getExternalStatus()
    {
        return $this->container['external_status'];
    }

    /**
     * Sets external_status
     *
     * @param string|null $external_status Статус заказа на доставку у службы доставки
     *
     * @return $this
     */
    public function setExternalStatus($external_status)
    {

        if (is_null($external_status)) {
            array_push($this->openAPINullablesSetToNull, 'external_status');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('external_status', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['external_status'] = $external_status;

        return $this;
    }

    /**
     * Gets external_status_at
     *
     * @return \DateTime|null
     */
    public function getExternalStatusAt()
    {
        return $this->container['external_status_at'];
    }

    /**
     * Sets external_status_at
     *
     * @param \DateTime|null $external_status_at Дата и время изменения статуса заказа на доставку у службы доставки
     *
     * @return $this
     */
    public function setExternalStatusAt($external_status_at)
    {

        if (is_null($external_status_at)) {
            array_push($this->openAPINullablesSetToNull, 'external_status_at');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('external_status_at', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['external_status_at'] = $external_status_at;

        return $this;
    }

    /**
     * Gets height
     *
     * @return int
     */
    public function getHeight()
    {
        return $this->container['height'];
    }

    /**
     * Sets height
     *
     * @param int $height Высота заказа (в мм)
     *
     * @return $this
     */
    public function setHeight($height)
    {


        /*if (is_null($height)) {
            throw new \InvalidArgumentException('non-nullable height cannot be null');
        }*/
        $this->container['height'] = $height;

        return $this;
    }

    /**
     * Gets length
     *
     * @return int
     */
    public function getLength()
    {
        return $this->container['length'];
    }

    /**
     * Sets length
     *
     * @param int $length Длина заказа (в мм)
     *
     * @return $this
     */
    public function setLength($length)
    {


        /*if (is_null($length)) {
            throw new \InvalidArgumentException('non-nullable length cannot be null');
        }*/
        $this->container['length'] = $length;

        return $this;
    }

    /**
     * Gets width
     *
     * @return int
     */
    public function getWidth()
    {
        return $this->container['width'];
    }

    /**
     * Sets width
     *
     * @param int $width Ширина заказа (в мм)
     *
     * @return $this
     */
    public function setWidth($width)
    {


        /*if (is_null($width)) {
            throw new \InvalidArgumentException('non-nullable width cannot be null');
        }*/
        $this->container['width'] = $width;

        return $this;
    }

    /**
     * Gets weight
     *
     * @return int
     */
    public function getWeight()
    {
        return $this->container['weight'];
    }

    /**
     * Sets weight
     *
     * @param int $weight Вес заказа (в граммах)
     *
     * @return $this
     */
    public function setWeight($weight)
    {


        /*if (is_null($weight)) {
            throw new \InvalidArgumentException('non-nullable weight cannot be null');
        }*/
        $this->container['weight'] = $weight;

        return $this;
    }

    /**
     * Gets shipment_method
     *
     * @return int
     */
    public function getShipmentMethod()
    {
        return $this->container['shipment_method'];
    }

    /**
     * Sets shipment_method
     *
     * @param int $shipment_method shipment_method
     *
     * @return $this
     */
    public function setShipmentMethod($shipment_method)
    {


        /*if (is_null($shipment_method)) {
            throw new \InvalidArgumentException('non-nullable shipment_method cannot be null');
        }*/
        $this->container['shipment_method'] = $shipment_method;

        return $this;
    }

    /**
     * Gets delivery_method
     *
     * @return int
     */
    public function getDeliveryMethod()
    {
        return $this->container['delivery_method'];
    }

    /**
     * Sets delivery_method
     *
     * @param int $delivery_method delivery_method
     *
     * @return $this
     */
    public function setDeliveryMethod($delivery_method)
    {


        /*if (is_null($delivery_method)) {
            throw new \InvalidArgumentException('non-nullable delivery_method cannot be null');
        }*/
        $this->container['delivery_method'] = $delivery_method;

        return $this;
    }

    /**
     * Gets delivery_date
     *
     * @return \DateTime|null
     */
    public function getDeliveryDate()
    {
        return $this->container['delivery_date'];
    }

    /**
     * Sets delivery_date
     *
     * @param \DateTime|null $delivery_date Желаемая дата доставки
     *
     * @return $this
     */
    public function setDeliveryDate($delivery_date)
    {

        if (is_null($delivery_date)) {
            array_push($this->openAPINullablesSetToNull, 'delivery_date');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('delivery_date', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['delivery_date'] = $delivery_date;

        return $this;
    }

    /**
     * Gets point_in_id
     *
     * @return int|null
     */
    public function getPointInId()
    {
        return $this->container['point_in_id'];
    }

    /**
     * Sets point_in_id
     *
     * @param int|null $point_in_id Id точки приема заказа
     *
     * @return $this
     */
    public function setPointInId($point_in_id)
    {

        if (is_null($point_in_id)) {
            array_push($this->openAPINullablesSetToNull, 'point_in_id');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('point_in_id', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['point_in_id'] = $point_in_id;

        return $this;
    }

    /**
     * Gets point_out_id
     *
     * @return int|null
     */
    public function getPointOutId()
    {
        return $this->container['point_out_id'];
    }

    /**
     * Sets point_out_id
     *
     * @param int|null $point_out_id Id точки выдачи заказа
     *
     * @return $this
     */
    public function setPointOutId($point_out_id)
    {

        if (is_null($point_out_id)) {
            array_push($this->openAPINullablesSetToNull, 'point_out_id');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('point_out_id', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['point_out_id'] = $point_out_id;

        return $this;
    }

    /**
     * Gets shipment_time_start
     *
     * @return \DateTime|null
     */
    public function getShipmentTimeStart()
    {
        return $this->container['shipment_time_start'];
    }

    /**
     * Sets shipment_time_start
     *
     * @param \DateTime|null $shipment_time_start Начальное время забора от продавца
     *
     * @return $this
     */
    public function setShipmentTimeStart($shipment_time_start)
    {

        if (is_null($shipment_time_start)) {
            array_push($this->openAPINullablesSetToNull, 'shipment_time_start');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('shipment_time_start', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['shipment_time_start'] = $shipment_time_start;

        return $this;
    }

    /**
     * Gets shipment_time_end
     *
     * @return \DateTime|null
     */
    public function getShipmentTimeEnd()
    {
        return $this->container['shipment_time_end'];
    }

    /**
     * Sets shipment_time_end
     *
     * @param \DateTime|null $shipment_time_end Конечное время забора от продавца
     *
     * @return $this
     */
    public function setShipmentTimeEnd($shipment_time_end)
    {

        if (is_null($shipment_time_end)) {
            array_push($this->openAPINullablesSetToNull, 'shipment_time_end');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('shipment_time_end', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['shipment_time_end'] = $shipment_time_end;

        return $this;
    }

    /**
     * Gets delivery_time_start
     *
     * @return \DateTime|null
     */
    public function getDeliveryTimeStart()
    {
        return $this->container['delivery_time_start'];
    }

    /**
     * Sets delivery_time_start
     *
     * @param \DateTime|null $delivery_time_start Начальное время доставки
     *
     * @return $this
     */
    public function setDeliveryTimeStart($delivery_time_start)
    {

        if (is_null($delivery_time_start)) {
            array_push($this->openAPINullablesSetToNull, 'delivery_time_start');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('delivery_time_start', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['delivery_time_start'] = $delivery_time_start;

        return $this;
    }

    /**
     * Gets delivery_time_end
     *
     * @return \DateTime|null
     */
    public function getDeliveryTimeEnd()
    {
        return $this->container['delivery_time_end'];
    }

    /**
     * Sets delivery_time_end
     *
     * @param \DateTime|null $delivery_time_end Конечное время доставки
     *
     * @return $this
     */
    public function setDeliveryTimeEnd($delivery_time_end)
    {

        if (is_null($delivery_time_end)) {
            array_push($this->openAPINullablesSetToNull, 'delivery_time_end');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('delivery_time_end', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['delivery_time_end'] = $delivery_time_end;

        return $this;
    }

    /**
     * Gets description
     *
     * @return string|null
     */
    public function getDescription()
    {
        return $this->container['description'];
    }

    /**
     * Sets description
     *
     * @param string|null $description Комментарий
     *
     * @return $this
     */
    public function setDescription($description)
    {

        if (is_null($description)) {
            array_push($this->openAPINullablesSetToNull, 'description');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('description', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['description'] = $description;

        return $this;
    }

    /**
     * Gets assessed_cost
     *
     * @return int|null
     */
    public function getAssessedCost()
    {
        return $this->container['assessed_cost'];
    }

    /**
     * Sets assessed_cost
     *
     * @param int|null $assessed_cost Оценочная стоимость / сумма страховки (в копейках)
     *
     * @return $this
     */
    public function setAssessedCost($assessed_cost)
    {

        if (is_null($assessed_cost)) {
            array_push($this->openAPINullablesSetToNull, 'assessed_cost');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('assessed_cost', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['assessed_cost'] = $assessed_cost;

        return $this;
    }

    /**
     * Gets delivery_cost
     *
     * @return int
     */
    public function getDeliveryCost()
    {
        return $this->container['delivery_cost'];
    }

    /**
     * Sets delivery_cost
     *
     * @param int $delivery_cost Стоимость доставки с учетом НДС (в копейках)
     *
     * @return $this
     */
    public function setDeliveryCost($delivery_cost)
    {


        /*if (is_null($delivery_cost)) {
            throw new \InvalidArgumentException('non-nullable delivery_cost cannot be null');
        }*/
        $this->container['delivery_cost'] = $delivery_cost;

        return $this;
    }

    /**
     * Gets delivery_cost_vat
     *
     * @return float|null
     */
    public function getDeliveryCostVat()
    {
        return $this->container['delivery_cost_vat'];
    }

    /**
     * Sets delivery_cost_vat
     *
     * @param float|null $delivery_cost_vat Процентная ставка НДС
     *
     * @return $this
     */
    public function setDeliveryCostVat($delivery_cost_vat)
    {

        if (is_null($delivery_cost_vat)) {
            array_push($this->openAPINullablesSetToNull, 'delivery_cost_vat');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('delivery_cost_vat', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['delivery_cost_vat'] = $delivery_cost_vat;

        return $this;
    }

    /**
     * Gets delivery_cost_pay
     *
     * @return int
     */
    public function getDeliveryCostPay()
    {
        return $this->container['delivery_cost_pay'];
    }

    /**
     * Sets delivery_cost_pay
     *
     * @param int $delivery_cost_pay Стоимость доставки к оплате с учетом НДС (в копейках)
     *
     * @return $this
     */
    public function setDeliveryCostPay($delivery_cost_pay)
    {


        /*if (is_null($delivery_cost_pay)) {
            throw new \InvalidArgumentException('non-nullable delivery_cost_pay cannot be null');
        }*/
        $this->container['delivery_cost_pay'] = $delivery_cost_pay;

        return $this;
    }

    /**
     * Gets cod_cost
     *
     * @return int|null
     */
    public function getCodCost()
    {
        return $this->container['cod_cost'];
    }

    /**
     * Sets cod_cost
     *
     * @param int|null $cod_cost Сумма наложенного платежа с учетом НДС (в копейках)
     *
     * @return $this
     */
    public function setCodCost($cod_cost)
    {

        if (is_null($cod_cost)) {
            array_push($this->openAPINullablesSetToNull, 'cod_cost');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('cod_cost', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['cod_cost'] = $cod_cost;

        return $this;
    }

    /**
     * Gets is_delivery_payed_by_recipient
     *
     * @return bool
     */
    public function getIsDeliveryPayedByRecipient()
    {
        return $this->container['is_delivery_payed_by_recipient'];
    }

    /**
     * Sets is_delivery_payed_by_recipient
     *
     * @param bool $is_delivery_payed_by_recipient Флаг для указания стороны, которая платит за услуги доставки (0-отправитель, 1-получатель)
     *
     * @return $this
     */
    public function setIsDeliveryPayedByRecipient($is_delivery_payed_by_recipient)
    {


        /*if (is_null($is_delivery_payed_by_recipient)) {
            throw new \InvalidArgumentException('non-nullable is_delivery_payed_by_recipient cannot be null');
        }*/
        $this->container['is_delivery_payed_by_recipient'] = $is_delivery_payed_by_recipient;

        return $this;
    }

    /**
     * Gets sender_is_seller
     *
     * @return bool
     */
    public function getSenderIsSeller()
    {
        return $this->container['sender_is_seller'];
    }

    /**
     * Sets sender_is_seller
     *
     * @param bool $sender_is_seller Отправитель является истинным продавцом, а не маркетплейсом?
     *
     * @return $this
     */
    public function setSenderIsSeller($sender_is_seller)
    {


        /*if (is_null($sender_is_seller)) {
            throw new \InvalidArgumentException('non-nullable sender_is_seller cannot be null');
        }*/
        $this->container['sender_is_seller'] = $sender_is_seller;

        return $this;
    }

    /**
     * Gets sender_inn
     *
     * @return string|null
     */
    public function getSenderInn()
    {
        return $this->container['sender_inn'];
    }

    /**
     * Sets sender_inn
     *
     * @param string|null $sender_inn ИНН отправителя
     *
     * @return $this
     */
    public function setSenderInn($sender_inn)
    {

        if (is_null($sender_inn)) {
            array_push($this->openAPINullablesSetToNull, 'sender_inn');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('sender_inn', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['sender_inn'] = $sender_inn;

        return $this;
    }

    /**
     * Gets sender_address
     *
     * @return \Ensi\LogisticClient\Dto\Address|null
     */
    public function getSenderAddress()
    {
        return $this->container['sender_address'];
    }

    /**
     * Sets sender_address
     *
     * @param \Ensi\LogisticClient\Dto\Address|null $sender_address sender_address
     *
     * @return $this
     */
    public function setSenderAddress($sender_address)
    {

        if (is_null($sender_address)) {
            array_push($this->openAPINullablesSetToNull, 'sender_address');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('sender_address', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['sender_address'] = $sender_address;

        return $this;
    }

    /**
     * Gets sender_company_name
     *
     * @return string|null
     */
    public function getSenderCompanyName()
    {
        return $this->container['sender_company_name'];
    }

    /**
     * Sets sender_company_name
     *
     * @param string|null $sender_company_name Название компании отправителя
     *
     * @return $this
     */
    public function setSenderCompanyName($sender_company_name)
    {

        if (is_null($sender_company_name)) {
            array_push($this->openAPINullablesSetToNull, 'sender_company_name');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('sender_company_name', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['sender_company_name'] = $sender_company_name;

        return $this;
    }

    /**
     * Gets sender_contact_name
     *
     * @return string|null
     */
    public function getSenderContactName()
    {
        return $this->container['sender_contact_name'];
    }

    /**
     * Sets sender_contact_name
     *
     * @param string|null $sender_contact_name ФИО контактного лица отправителя
     *
     * @return $this
     */
    public function setSenderContactName($sender_contact_name)
    {

        if (is_null($sender_contact_name)) {
            array_push($this->openAPINullablesSetToNull, 'sender_contact_name');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('sender_contact_name', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['sender_contact_name'] = $sender_contact_name;

        return $this;
    }

    /**
     * Gets sender_email
     *
     * @return string|null
     */
    public function getSenderEmail()
    {
        return $this->container['sender_email'];
    }

    /**
     * Sets sender_email
     *
     * @param string|null $sender_email Контактный email отправителя
     *
     * @return $this
     */
    public function setSenderEmail($sender_email)
    {

        if (is_null($sender_email)) {
            array_push($this->openAPINullablesSetToNull, 'sender_email');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('sender_email', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['sender_email'] = $sender_email;

        return $this;
    }

    /**
     * Gets sender_phone
     *
     * @return string|null
     */
    public function getSenderPhone()
    {
        return $this->container['sender_phone'];
    }

    /**
     * Sets sender_phone
     *
     * @param string|null $sender_phone Контактный email отправителя
     *
     * @return $this
     */
    public function setSenderPhone($sender_phone)
    {

        if (is_null($sender_phone)) {
            array_push($this->openAPINullablesSetToNull, 'sender_phone');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('sender_phone', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['sender_phone'] = $sender_phone;

        return $this;
    }

    /**
     * Gets sender_comment
     *
     * @return string|null
     */
    public function getSenderComment()
    {
        return $this->container['sender_comment'];
    }

    /**
     * Sets sender_comment
     *
     * @param string|null $sender_comment Комментарий отправителя
     *
     * @return $this
     */
    public function setSenderComment($sender_comment)
    {

        if (is_null($sender_comment)) {
            array_push($this->openAPINullablesSetToNull, 'sender_comment');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('sender_comment', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['sender_comment'] = $sender_comment;

        return $this;
    }

    /**
     * Gets recipient_address
     *
     * @return \Ensi\LogisticClient\Dto\Address|null
     */
    public function getRecipientAddress()
    {
        return $this->container['recipient_address'];
    }

    /**
     * Sets recipient_address
     *
     * @param \Ensi\LogisticClient\Dto\Address|null $recipient_address recipient_address
     *
     * @return $this
     */
    public function setRecipientAddress($recipient_address)
    {

        if (is_null($recipient_address)) {
            array_push($this->openAPINullablesSetToNull, 'recipient_address');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('recipient_address', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['recipient_address'] = $recipient_address;

        return $this;
    }

    /**
     * Gets recipient_company_name
     *
     * @return string|null
     */
    public function getRecipientCompanyName()
    {
        return $this->container['recipient_company_name'];
    }

    /**
     * Sets recipient_company_name
     *
     * @param string|null $recipient_company_name Название компании получателя
     *
     * @return $this
     */
    public function setRecipientCompanyName($recipient_company_name)
    {

        if (is_null($recipient_company_name)) {
            array_push($this->openAPINullablesSetToNull, 'recipient_company_name');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('recipient_company_name', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['recipient_company_name'] = $recipient_company_name;

        return $this;
    }

    /**
     * Gets recipient_contact_name
     *
     * @return string|null
     */
    public function getRecipientContactName()
    {
        return $this->container['recipient_contact_name'];
    }

    /**
     * Sets recipient_contact_name
     *
     * @param string|null $recipient_contact_name ФИО контактного лица получателя
     *
     * @return $this
     */
    public function setRecipientContactName($recipient_contact_name)
    {

        if (is_null($recipient_contact_name)) {
            array_push($this->openAPINullablesSetToNull, 'recipient_contact_name');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('recipient_contact_name', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['recipient_contact_name'] = $recipient_contact_name;

        return $this;
    }

    /**
     * Gets recipient_email
     *
     * @return string|null
     */
    public function getRecipientEmail()
    {
        return $this->container['recipient_email'];
    }

    /**
     * Sets recipient_email
     *
     * @param string|null $recipient_email Контактный email получателя
     *
     * @return $this
     */
    public function setRecipientEmail($recipient_email)
    {

        if (is_null($recipient_email)) {
            array_push($this->openAPINullablesSetToNull, 'recipient_email');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('recipient_email', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['recipient_email'] = $recipient_email;

        return $this;
    }

    /**
     * Gets recipient_phone
     *
     * @return string|null
     */
    public function getRecipientPhone()
    {
        return $this->container['recipient_phone'];
    }

    /**
     * Sets recipient_phone
     *
     * @param string|null $recipient_phone Контактный email получателя
     *
     * @return $this
     */
    public function setRecipientPhone($recipient_phone)
    {

        if (is_null($recipient_phone)) {
            array_push($this->openAPINullablesSetToNull, 'recipient_phone');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('recipient_phone', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['recipient_phone'] = $recipient_phone;

        return $this;
    }

    /**
     * Gets recipient_comment
     *
     * @return string|null
     */
    public function getRecipientComment()
    {
        return $this->container['recipient_comment'];
    }

    /**
     * Sets recipient_comment
     *
     * @param string|null $recipient_comment Комментарий получателя
     *
     * @return $this
     */
    public function setRecipientComment($recipient_comment)
    {

        if (is_null($recipient_comment)) {
            array_push($this->openAPINullablesSetToNull, 'recipient_comment');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('recipient_comment', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['recipient_comment'] = $recipient_comment;

        return $this;
    }

    /**
     * Gets created_at
     *
     * @return \DateTime
     */
    public function getCreatedAt()
    {
        return $this->container['created_at'];
    }

    /**
     * Sets created_at
     *
     * @param \DateTime $created_at Дата создания
     *
     * @return $this
     */
    public function setCreatedAt($created_at)
    {


        /*if (is_null($created_at)) {
            throw new \InvalidArgumentException('non-nullable created_at cannot be null');
        }*/
        $this->container['created_at'] = $created_at;

        return $this;
    }

    /**
     * Gets updated_at
     *
     * @return \DateTime
     */
    public function getUpdatedAt()
    {
        return $this->container['updated_at'];
    }

    /**
     * Sets updated_at
     *
     * @param \DateTime $updated_at Дата обновления
     *
     * @return $this
     */
    public function setUpdatedAt($updated_at)
    {


        /*if (is_null($updated_at)) {
            throw new \InvalidArgumentException('non-nullable updated_at cannot be null');
        }*/
        $this->container['updated_at'] = $updated_at;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset): bool
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed
     */
    public function offsetGet($offset): mixed
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     *
     * @param integer $offset Offset
     * @param mixed   $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value): void
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset): void
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        return json_encode(
            ObjectSerializer::sanitizeForSerialization($this),
            JSON_PRETTY_PRINT
        );
    }

    /**
     * Gets a header-safe presentation of the object
     *
     * @return string
     */
    public function toHeaderValue()
    {
        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }

    /**
    * Convert object to array
    *
    * @return array
    */
    public function toArray()
    {
        return json_decode(json_encode(ObjectSerializer::sanitizeForSerialization($this)), true);
    }
}


